﻿Imports System.ComponentModel
Imports System.Text
Imports Goldammer

Namespace Online_Trigger
	Partial Public Class Form1
		Inherits Form
		Public Sub New()
			InitializeComponent()
		End Sub

		Private m_firstDev As MAIDevice = Nothing
		Private m_Measure As Boolean = False

		Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
			m_firstDev = Goldammer.MAI.Devices(0)
			If m_firstDev Is Nothing Then
				MessageBox.Show("No Card found.")
				Close()
			End If
			If Not m_firstDev.HasSoftwareExtension(SWExtension.Online_PID) Then
				MessageBox.Show("This Card does not support Trigger Functions.")
				Close()
			End If
			AddHandler m_firstDev.ADChannels.ProcessDataBuffers, AddressOf ADChannels_ProcessDataBuffers

			InitComboboxes()
		End Sub

		Private Function GetTrigger1() As RealtimeSetupTrigger
			Try
				Dim t As RealtimeSetupTrigger
				t.Aktiv = checkBoxStartTriggerActive.Checked
				t.EnabledAtStart = checkBoxStartTriggerEnabled.Checked
				t.Schwellwert1 = Convert.ToDouble(textBoxstartTrigtresh1.Text)
				t.Schwellwert2 = Convert.ToDouble(textBoxstartTrigtresh2.Text)
				t.TriggerSetztTTL = checkBoxStartSetsTTL.Checked
				t.TTLKlemme = Convert.ToUInt32(textBoxTTLChannelStart.Text)
				If m_firstDev IsNot Nothing Then
					m_firstDev.TTLChannels(CInt(t.TTLKlemme)).SetChannelDirection(IODirection.Output)
				End If
				t.TTLStartZustand = CType(comboBoxStartTTLInit.SelectedIndex, IOBitState)
				t.TTLTriggeredZustand = CType(comboBoxStartTTLTriggered.SelectedIndex, IOBitState)
				t.Typ = CType(comboBoxMode1.SelectedIndex, TriggerType)
				t.TriggerStartetMessung = checkBoxStartTriggerMeasure.Checked
				Return t
			Catch e1 As Exception
				MessageBox.Show("Invalid number in Trigger 1")
				Throw
			End Try
		End Function
		Private Function GetTrigger2() As RealtimeSetupTrigger
			Try
				Dim t As RealtimeSetupTrigger
				t.Aktiv = checkBoxStopTriggerActive.Checked
				t.EnabledAtStart = checkBoxStopTriggerEnable.Checked
				t.Schwellwert1 = Convert.ToDouble(textBoxStopTrigtresh1.Text)
				t.Schwellwert2 = Convert.ToDouble(textBoxStopTrigtresh2.Text)
				t.TriggerSetztTTL = checkBoxStopSetsTTL.Checked
				t.TTLKlemme = Convert.ToUInt32(textBoxTTLChannelStop.Text)
				If m_firstDev IsNot Nothing Then
					m_firstDev.TTLChannels(CInt(t.TTLKlemme)).SetChannelDirection(IODirection.Output)
				End If
				t.TTLStartZustand = CType(comboBoxStopTTLInit.SelectedIndex, IOBitState)
				t.TTLTriggeredZustand = CType(comboBoxStopTTLTriggered.SelectedIndex, IOBitState)
				t.Typ = CType(comboBoxMode2.SelectedIndex, TriggerType)
				t.TriggerStartetMessung = checkBoxStopTriggerMeas.Checked
				Return t
			Catch e1 As Exception
				MessageBox.Show("Invalid number in Trigger 2")
				Throw
			End Try
		End Function
		Private Sub InitComboboxes()
			comboBoxMode1.SelectedIndex = 3
			comboBoxMode2.SelectedIndex = 2
			comboBoxStartTTLInit.SelectedIndex = 0
			comboBoxStartTTLTriggered.SelectedIndex = 1
			comboBoxStopTTLInit.SelectedIndex = 1
			comboBoxStopTTLTriggered.SelectedIndex = 0
		End Sub

		Private Sub ADChannels_ProcessDataBuffers(ByVal obj As Object, ByVal args As EventArgs)
			Try
				SetTextboxText("")

				Dim NofValues As UInteger = m_firstDev.ADChannels.GetNumberOfValues()
				Dim Values() As Double = Nothing
				For Each c As MAIMeasurementChannelAD In m_firstDev.ADChannels.GetMeasurementChannels()
					Values = c.ReadData(NofValues)
				Next c
				If Values Is Nothing Then
					Return
				End If
				Dim textboxtxt As String = ""
				For i As Integer = 0 To 9
					If i >= Values.Length Then
						Return
					End If
					textboxtxt &= Values(i).ToString() & Environment.NewLine
				Next i
				SetTextboxText(textboxtxt)

			Catch ex As Exception
				MessageBox.Show(ex.Message)
			End Try
		End Sub

		Private Sub SetTextboxText(ByVal AITextboxText As String)
			If InvokeRequired Then ' muss den Main-Thread "invoken", der Aufruf passiert ja aus dem Notification Thread heraus.
				Dim invoker As New MethodInvoker(Function() AnonymousMethod1(AITextboxText))
				Invoke(invoker)
			Else
				textBox1.Text = AITextboxText
			End If
		End Sub
		
		Private Function AnonymousMethod1(ByVal AITextboxText As String) As Object
			textBox1.Text = AITextboxText
			Return Nothing
		End Function

		Private Sub trackBar1_Scroll(ByVal sender As Object, ByVal e As EventArgs) Handles trackBar1.Scroll
			If m_firstDev Is Nothing Then
				Return
			End If
			If m_firstDev.DAChannels.HardwareChannelCount < 1 Then
				Return
			End If
			Dim NuVal As Double = (CDbl(trackBar1.Value)) / 100.0
			labelDALastValue.Text = NuVal.ToString()
			Try
				m_firstDev.DAChannels(0).WriteChannelVoltage(NuVal)
			Catch ex As Exception
				MessageBox.Show(ex.Message)
			End Try
		End Sub

		Private Sub buttonStart_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonStart.Click
			If m_firstDev Is Nothing Then
				Return
			End If
			m_firstDev.StopMeasure()
			m_firstDev.ADChannels.StopNotificationThread()
			m_firstDev.ClearAllChannelLists()
			Try
				If Not m_Measure Then

					Dim c As MAIMeasurementChannelAD = m_firstDev.ADChannels(0).CreateMeasurementChannel(OversamplingMode.Disabled, GainFactor.Disabled, True)
					m_firstDev.ADChannels.SetSampleRate(250)
					m_firstDev.ADChannels.SetMeasurementBufferNotificationLevel(10)
					c.Realtime.AddTrigger(GetTrigger1(), GetTrigger2(), checkBoxReTrigger.Checked)
					m_firstDev.ADChannels.SetPrePostTriggerValues(0, 0, True)
					m_firstDev.ConfigMeasure()
					m_firstDev.ADChannels.StartNotificationThread()
					m_firstDev.ADChannels.StartMeasurement()

					groupBox1.Enabled = False
					groupBox2.Enabled = False
					buttonStart.Text = "Stop"
					m_Measure = True

				Else
					groupBox1.Enabled = True
					groupBox2.Enabled = True
					buttonStart.Text = "Start"
					m_Measure = False
				End If
			Catch ex As Exception
				MessageBox.Show(ex.Message)
				m_firstDev.StopMeasure()
				m_firstDev.ADChannels.StopNotificationThread()
				m_firstDev.ClearAllChannelLists()
				groupBox1.Enabled = True
				groupBox2.Enabled = True
				buttonStart.Text = "Start"
				m_Measure = False

			End Try


		End Sub


	End Class
End Namespace
